VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CLanguage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

'CLanguage
'Handles the internationalization of all user interface components.
'Usage: 1 Add to project
'       2 Ensure that Microsoft Scripting Runtime has a reference in the project
'       3 Ensure that Microsft XML has a reference in the project
'       4 Ensure everything you want to internationalize has a unique .tag attribute
'       5 Add languages.xml to main program directory and populate with information
'       6 Change every string "example" to GetText("example")
'       7 Create an instance of the object.
' Of course, this considerably under-states the work needed for step 3. You can use
' RegisterForm to help you.

Option Explicit

Private translator As New Dictionary
Private mstrFontname As String
Private mintCharset As Integer
Private cLanguage As String

'Public Sub UpdateToolbarLanguage(toolbar As Control)
''updates toolbar controls with international text
'    On Error Resume Next
'    Dim tbButton As button
'    Dim got As String
'    For Each tbButton In toolbar.Buttons
'        If Len(tbButton.Tag) > 0 Then
'            tbButton.Caption = mobjUIComponents.item(tbButton.Tag & ".Caption")
'            got = mobjUIComponents.item(tbButton.Tag & ".ToolTipText")
'            If got <> "#" Then
'                tbButton.ToolTipText = mobjUIComponents.item(tbButton.Tag & ".ToolTipText")
'            End If
'        End If
'    Next tbButton
'End Sub
''
'Public Sub UpdateCoolbarLanguage(coolbar As Control)
''updates coolbar controls with international text
'    On Error Resume Next
'    Dim tbButton As Band
'    Dim got As String
'    For Each tbButton In coolbar.Bands
'        If Len(tbButton.Tag) > 0 Then
'            tbButton.Caption = mobjUIComponents.item(tbButton.Tag & ".Caption")
'            got = mobjUIComponents.item(tbButton.Tag & ".ToolTipText")
'        End If
'    Next tbButton
'End Sub
'
'Public Sub UpdateStatusBarLanguage(statusbar As Control)
''updates toolbar controls with international text
'    On Error Resume Next
'    Dim aPanel As Panel
'    Dim got As String
'    For Each aPanel In statusbar.Panels
'        If Len(aPanel.Tag) > 0 Then
'            got = mobjUIComponents.item(aPanel.Tag & ".ToolTipText")
'            If got <> "#" Then
'                aPanel.ToolTipText = mobjUIComponents.item(aPanel.Tag & ".ToolTipText")
'            End If
'        End If
'    Next aPanel
'End Sub

'Private Sub UpdateComboboxLanguage(aComboBox As Control)
''updates combobox controls with international text, which in this instance
''means clearing the box and adding a new default
'    On Error Resume Next
'    Dim got As String
'
'    If Len(aComboBox.Tag) > 0 Then
'        got = translator.item(aComboBox.Tag)
'        If got <> "#" Then
'            Call aComboBox.Clear
'            Call aComboBox.AddItem(got)
'        End If
'    End If
'End Sub

Public Sub UpdateLanguage(aForm As Form)
'goes through the form updating the user components
    On Error Resume Next
    Dim aControl As Control
    Dim got As String

    'do caption
    aForm.Caption = translator.item(aForm.name)
    'do font
    aForm.Font.name = mstrFontname
    'do others
    For Each aControl In aForm.Controls
        ''If TypeOf aControl Is statusbar Then Call UpdateStatusBarLanguage(aControl)
        ''If TypeOf aControl Is toolbar Then Call UpdateToolbarLanguage(aControl)
        ''If TypeOf aControl Is coolbar Then Call UpdateCoolbarLanguage(aControl)
        ''If TypeOf aControl Is ComboBox Then Call UpdateComboboxLanguage(aControl)
        If Len(aControl.Tag) > 0 Then
            'got a tag: get details
            'Caption
            If TypeOf aControl Is Label Or TypeOf aControl Is OptionButton Or _
            TypeOf aControl Is Menu Or TypeOf aControl Is CommandButton Or _
            TypeOf aControl Is Frame Or TypeOf aControl Is CheckBox Then
                aControl.Caption = translator.item(aControl.Tag)
            End If
            'font
            If Not TypeOf aControl Is Menu Then
                'Debug.Print "WAS: <" & aControl.Font.name & ">"
                aControl.Font.name = mstrFontname
                'Debug.Print "WAS: " & aControl.name & ":" & aControl.Font.charset
                aControl.Font.Charset = mintCharset
                'Debug.Print "NOW: " & aControl.Font.charset
                'Debug.Print "NOW: " & aControl.name & ":<" & aControl.Font.name & "> (should be <" & mstrFontname & ">)"
            End If
        Else
            'Debug.Print "Loading: Not found type: " & aForm.name & "." & aControl.name
        End If
    Next aControl
End Sub

Public Sub RegisterForm(aForm As Form)
'saves the information about the form
    On Error Resume Next
    Dim aControl As Control
    Dim parentName As String
    Dim fso As New FileSystemObject
    Dim ts As TextStream
    Dim item As String

    parentName = aForm.name
    Set ts = fso.OpenTextFile(App.path & "\allforms.txt", ForAppending, True, TristateFalse)
    item = vbTab & vbTab & "<item what=""Caption"" key=""" & aForm.name & """>" & aForm.Caption & "</item>" & vbNewLine
    Call ts.Write(item)
    For Each aControl In aForm.Controls
        If Len(aControl.Tag) > 0 Then
            'got a tag: record details
            'Caption
            If TypeOf aControl Is Label Or TypeOf aControl Is OptionButton Or _
            TypeOf aControl Is Menu Or TypeOf aControl Is CommandButton Or _
            TypeOf aControl Is Frame Or TypeOf aControl Is CheckBox Then
                item = vbTab & vbTab & "<item what=""Caption"" key=""" & aControl.Tag & """>" & aControl.Caption & "</item>" & vbNewLine
                Call ts.Write(item)
            End If
        End If
    Next aControl
    Call ts.Close
End Sub

Public Function GetText(key As String) As String
    'returns the internationalised string for the given key.
    On Error Resume Next
    If translator.Exists(key) Then
        GetText = translator.item(key)
    Else
        GetText = key
    End If
End Function


Private Sub Class_Initialize()
'loads a language file containing translations, if there is one
    On Error Resume Next
    cLanguage = GetSetting(App.Title, "User Settings", "Language", "English")
    Call SetLanguage(cLanguage)
End Sub

Private Sub Class_Terminate()
    On Error Resume Next
    Call SaveSetting(App.Title, "User Settings", "Language", cLanguage)
End Sub

Public Property Let language(newLanguage As String)
'allows an applicaiton to change the language used
    On Error Resume Next
    Call SetLanguage(newLanguage)
End Property

Public Property Get language() As String
    On Error Resume Next
    language = cLanguage
End Property

Private Sub SetLanguage(newLanguage As String)
'loads and parses the language requested, or uses English if not found
    On Error GoTo ErrorInitialise
    Dim languageDoc As New DOMDocument30
    Dim itemIterator As IXMLDOMNode
    Dim languageNode As IXMLDOMNode
    Dim foundFont As Boolean
    Dim i As Integer
    Dim aForm As Form
    
    Call languageDoc.Load(App.path & "\languages.xml")
    'check we have the language requested
    If languageDoc.documentElement.selectNodes("language[@name='" & newLanguage & "']").length = 0 Then
        'didn't find that language: use english
        cLanguage = "English"
    Else
        cLanguage = newLanguage
    End If
    Call translator.RemoveAll
    Set languageNode = languageDoc.documentElement.selectSingleNode("language[@name='" & cLanguage & "']")
    For Each itemIterator In languageNode.selectNodes("item")
        Call translator.add(itemIterator.attributes.getNamedItem("key").Text, itemIterator.Text)
    Next itemIterator
   
    'now get the font to use
    mstrFontname = languageNode.attributes.getNamedItem("font").Text
    mintCharset = languageNode.attributes.getNamedItem("charset").Text
    'check we have it
    foundFont = False
    For i = 1 To Screen.FontCount
        If Screen.Fonts(i) = mstrFontname Then
            foundFont = True
        End If
    Next i
    If foundFont Then
        'we found the preferred font on this machine: we can use it (i.e. mstrFontname
        'is valid)
    Else
        'this font isn't on this machine: use MS Sans Serif
        mstrFontname = "MS Sans Serif"
    End If
    'now update all the forms
    For Each aForm In Forms
        Call UpdateLanguage(aForm)
    Next aForm
    Exit Sub
ErrorInitialise:

End Sub
