VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CAttribute"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

Option Explicit

Private cName As String
Private cType As String     'e.g. Operation or Attribute
Private cValue As String    'e.g. int or String
Private cVisibility As String
Private cParameters As Collection

Public Property Get name() As String
    On Error Resume Next
    name = cName
End Property

Public Property Let name(newName As String)
    On Error Resume Next
    cName = newName
End Property

Public Property Get attributeValue() As String
    On Error Resume Next
    attributeValue = cValue
End Property

Public Property Let attributeValue(newAttributeValue As String)
    On Error Resume Next
    cValue = newAttributeValue
End Property

Public Property Get attributeType() As String
    On Error Resume Next
    attributeType = cType
End Property

Public Property Let attributeType(newAttributeType As String)
    On Error Resume Next
    cType = newAttributeType
End Property

Public Property Get visibility() As String
    On Error Resume Next
    visibility = cVisibility
End Property

Public Property Let visibility(newVisibility As String)
    On Error Resume Next
    cVisibility = newVisibility
End Property

Public Property Get parameters() As Collection
    On Error Resume Next
    Set parameters = cParameters
End Property

Public Property Get description() As String
    On Error Resume Next
'returns a ready-to-go description of the attribute
    Dim desc As String
    Dim i As Integer
    Dim returnType As String
    Dim parameterIterator As CParameter
    
    If cType = "Attribute" Then
        desc = cVisibility & " " & cType & " " & cName
        desc = desc & " : " & cValue
    ElseIf cType = "Operation" Then
        'okay, this is an operation: should be in the form
        ' visibility type name(parameters)
        'eg
        'public String description()
        desc = cVisibility & " " & cValue & " " & cType & " " & cName
        'now do operations
        desc = desc & "("
        For Each parameterIterator In cParameters
            If parameterIterator.kind = "in" Then
                desc = desc & parameterIterator.parameterType & " " & parameterIterator.name & ","
            End If
            If parameterIterator.kind = "return" Then
                returnType = parameterIterator.parameterType
            End If
        Next parameterIterator
        'take off any extra comma
        If Right(desc, 1) = "," Then desc = Left(desc, Len(desc) - 1)
        desc = desc & "): "
        If returnType = Empty Then
            desc = desc & "Void"
        Else
            desc = desc & returnType
        End If
    ElseIf cType = "Stereotype" Then
        desc = "Stereotype: " & cName
    ElseIf cType = "Diagram text" Then
        desc = cName
    End If
    description = desc
End Property
    
Private Sub Class_Initialize()
    On Error Resume Next
    Set cParameters = New Collection
End Sub

Public Sub ParseXML(source As IXMLDOMNode)
'parses the XML structure of an attribute into this current attribute node
    On Error Resume Next
    Dim parameterIterator As IXMLDOMNode
    Dim newParameter As CParameter
    
    cName = source.attributes.getNamedItem("name").Text
    cType = source.attributes.getNamedItem("type").Text
    cValue = source.attributes.getNamedItem("value").Text
    cVisibility = source.attributes.getNamedItem("visibility").Text
    For Each parameterIterator In source.selectNodes("parameter")
        'parse into a parameter
        Set newParameter = New CParameter
        newParameter.name = parameterIterator.attributes.getNamedItem("name").Text
        newParameter.kind = parameterIterator.attributes.getNamedItem("kind").Text
        newParameter.parameterType = parameterIterator.attributes.getNamedItem("type").Text
        Call cParameters.add(newParameter)
    Next parameterIterator
End Sub

