<?xml version="1.0"?>
<xsl:stylesheet
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
      version="1.0">
      <xsl:output method = "xml" omit-xml-declaration="yes"/>
   <xsl:template match="diagram">
   		<!-- for Sequence diagrams
   		<xsl:variable name="transformX">0</xsl:variable>
   		<xsl:variable name="transformY">10</xsl:variable>
   		<xsl:variable name="scaleX">300</xsl:variable>
   		<xsl:variable name="scaleY">25</xsl:variable> -->
   		<!-- for floorplans -->
   		<xsl:variable name="transformX">10</xsl:variable>
   		<xsl:variable name="transformY">10</xsl:variable>
   		<xsl:variable name="scaleX">
   			<xsl:choose>
   				<xsl:when test="//node[@type = 'Message recipient'] or //node[@type = 'Message origin']">
   					<xsl:text>300</xsl:text>
   				</xsl:when>
   				<xsl:otherwise>
   					<xsl:text>1</xsl:text>
   				</xsl:otherwise>
   			</xsl:choose>
   		</xsl:variable>
   		<xsl:variable name="scaleY">
   			<xsl:choose>
   				<xsl:when test="//node[@type = 'Message recipient'] or //node[@type = 'Message origin']">
   					<xsl:text>50</xsl:text>
   				</xsl:when>
   				<xsl:otherwise>
   					<xsl:text>1</xsl:text>
   				</xsl:otherwise>
   			</xsl:choose>
   		</xsl:variable>
       	<svg width="100%" height="100%" xmlns="http://www.w3.org/2000/svg">
	 		<xsl:for-each select="//node[location]">
				<xsl:comment><xsl:text>Node: </xsl:text><xsl:value-of select="@name"/></xsl:comment>
				<xsl:variable name="nodeName" select="@name"/>
				<xsl:variable name="xCoordGot" select="location/@x"/>
				<xsl:variable name="xCoord"><xsl:value-of select="$xCoordGot * $scaleX + $transformX"/></xsl:variable>
				<xsl:variable name="yCoordGot" select="location/@y"/>
				<xsl:variable name="yCoord"><xsl:value-of select="$yCoordGot * $scaleY + $transformY"/></xsl:variable>
				<xsl:variable name="uniqueID" select="@id"/>
				<!-- The lines from each node to connected nodes -->
				<xsl:for-each select="connection">
					<xsl:variable name="to" select="@href" />
					<xsl:for-each select="//*[@id = $to]">
						<xsl:if test="local-name() = 'connectionEnd'">
							<xsl:for-each select="parent::*/connectionEnd[@href != $uniqueID]">
								<!-- got the connectionEnd that doesn't point to me -->
								<xsl:variable name="otherXCoordGot" select="//node[@id = current()/@href]/location/attribute::x "/>
								<xsl:variable name="otherXCoord"><xsl:value-of select="$otherXCoordGot * $scaleX + $transformX"/></xsl:variable>
								<xsl:variable name="otherYCoordGot" select="//node[@id = current()/@href]/location/attribute::y"/>
								<xsl:variable name="otherYCoord"><xsl:value-of select="$otherYCoordGot * $scaleY + $transformY"/></xsl:variable>
								<path stroke-width="3" stroke="black" stroke-opacity="100">
									<!-- <xsl:attribute name="transform">translate(<xsl:value-of select="$transformX"/>,<xsl:value-of select="$transformY"/>) scale(<xsl:value-of select="$scaleX"/>,<xsl:value-of select="$scaleY"/>)</xsl:attribute> -->
									<xsl:attribute name="d">M <xsl:value-of select="$xCoord"/>&#x20;<xsl:value-of select="$yCoord"/> L <xsl:value-of select="$otherXCoord"/>&#x20;<xsl:value-of select="$otherYCoord"/></xsl:attribute>
								</path>
							</xsl:for-each>
						</xsl:if>
						<xsl:if test="local-name() != 'connectionEnd'">
							<xsl:variable name="otherXCoordGot" select="location/attribute::x"/>
							<xsl:variable name="otherXCoord"><xsl:value-of select="$otherXCoordGot * $scaleX + $transformX"/></xsl:variable>
							<xsl:variable name="otherYCoordGot" select="location/attribute::y"/>
							<xsl:variable name="otherYCoord"><xsl:value-of select="$otherYCoordGot * $scaleY + $transformY"/></xsl:variable>
							<path stroke-width="3" stroke="black" stroke-opacity="100">
								<!-- 	<xsl:attribute name="transform">translate(<xsl:value-of select="$transformX"/>,<xsl:value-of select="$transformY"/>) scale(<xsl:value-of select="$scaleX"/>,<xsl:value-of select="$scaleY"/>)</xsl:attribute> -->
								<xsl:attribute name="d">M <xsl:value-of select="$xCoord"/>&#x20;<xsl:value-of select="$yCoord"/> L <xsl:value-of  select="$otherXCoord"/>&#x20;<xsl:value-of select="$otherYCoord"/></xsl:attribute>
							</path>
						</xsl:if>
					</xsl:for-each>
				</xsl:for-each>
				<xsl:for-each select="connectionEnd">
					<xsl:variable name="to" select="@href" />
					<xsl:for-each select="//*[@id = $to]">
						<xsl:if test="local-name() = 'connectionEnd'">
							<xsl:for-each select="parent::*/connectionEnd[@href != $uniqueID]">
								<!-- got the connectionEnd that doesn't point to me -->
								<xsl:variable name="otherXCoordGot" select="//node[@id = current()/@href]/location/attribute::x "/>
								<xsl:variable name="otherXCoord"><xsl:value-of select="$otherXCoordGot * $scaleX + $transformX"/></xsl:variable>
								<xsl:variable name="otherYCoordGot" select="//node[@id = current()/@href]/location/attribute::y"/>
								<xsl:variable name="otherYCoord"><xsl:value-of select="$otherYCoordGot * $scaleY + $transformY"/></xsl:variable>
								<path stroke-width="3" stroke="black" stroke-opacity="100">
									<!-- <xsl:attribute name="transform">translate(<xsl:value-of select="$transformX"/>,<xsl:value-of select="$transformY"/>) scale(<xsl:value-of select="$scaleX"/>,<xsl:value-of select="$scaleY"/>)</xsl:attribute> -->
									<xsl:attribute name="d">M <xsl:value-of select="$xCoord"/>&#x20;<xsl:value-of select="$yCoord"/> L <xsl:value-of select="$otherXCoord"/>&#x20;<xsl:value-of select="$otherYCoord"/></xsl:attribute>
								</path>
							</xsl:for-each>
						</xsl:if>
						<xsl:if test="local-name() != 'connectionEnd'">
							<xsl:variable name="otherXCoordGot" select="location/attribute::x"/>
							<xsl:variable name="otherXCoord"><xsl:value-of select="$otherXCoordGot * $scaleX + $transformX"/></xsl:variable>
							<xsl:variable name="otherYCoordGot" select="location/attribute::y"/>
							<xsl:variable name="otherYCoord"><xsl:value-of select="$otherYCoordGot * $scaleY + $transformY"/></xsl:variable>
							<path stroke-width="3" stroke="black" stroke-opacity="100">
								<!-- 	<xsl:attribute name="transform">translate(<xsl:value-of select="$transformX"/>,<xsl:value-of select="$transformY"/>) scale(<xsl:value-of select="$scaleX"/>,<xsl:value-of select="$scaleY"/>)</xsl:attribute> -->
								<xsl:attribute name="d">M <xsl:value-of select="$xCoord"/>&#x20;<xsl:value-of select="$yCoord"/> L <xsl:value-of  select="$otherXCoord"/>&#x20;<xsl:value-of select="$otherYCoord"/></xsl:attribute>
							</path>
						</xsl:if>
					</xsl:for-each>
				</xsl:for-each>
			</xsl:for-each>
			<xsl:for-each select="//node[location]">
				<xsl:variable name="nodeName" select="@name"/>
				<xsl:variable name="xCoordGot" select="location/@x"/>
				<xsl:variable name="xCoord"><xsl:value-of select="$xCoordGot * $scaleX + $transformX"/></xsl:variable>
				<xsl:variable name="yCoordGot" select="location/@y"/>
				<xsl:variable name="yCoord"><xsl:value-of select="$yCoordGot * $scaleY + $transformY"/></xsl:variable>
				<xsl:variable name="uniqueID" select="@id"/>
				<xsl:variable name="textWidth" select="string-length($nodeName)"/>
				<!-- The rectangle behind the text -->
				<rect height="15" stroke="black">
					<!-- <xsl:attribute name="transform">translate(<xsl:value-of select="$transformX"/>,<xsl:value-of select="$transformY"/>) scale(<xsl:value-of select="$scaleX"/>,<xsl:value-of select="$scaleY"/>)</xsl:attribute> -->
					<xsl:attribute name="fill">
						<xsl:choose>
							<xsl:when test="@type='Association' or @type='Generalization'">
								<xsl:text>yellow</xsl:text>
							</xsl:when>
							<xsl:otherwise>
								<xsl:text>white</xsl:text>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>
					<xsl:attribute name="width">
						<xsl:value-of select="8 * $textWidth" />
					</xsl:attribute>
					<xsl:attribute name="x">
						<xsl:value-of select="$xCoord - 4 * $textWidth"/>
					</xsl:attribute>
					<xsl:attribute name="y">
						<xsl:value-of select="$yCoord - 10 "/>
					</xsl:attribute>
				</rect>
				<!-- The text of the node -->
				<text text-anchor="middle" textWidth="100">
					<!-- <xsl:attribute name="transform">translate(<xsl:value-of select="$transformX"/>,<xsl:value-of select="$transformY"/>) scale(<xsl:value-of select="$scaleX"/>,<xsl:value-of select="$scaleY"/>)</xsl:attribute> -->
					<xsl:attribute name="x">
						<xsl:value-of select="$xCoord"/>
					</xsl:attribute>
					<xsl:attribute name="y">
						<xsl:value-of select="$yCoord"/>
					</xsl:attribute>
					<!-- (<xsl:value-of select="@type"/>): --><xsl:value-of select="$nodeName"/>
				</text>
			</xsl:for-each>
 		</svg>
   </xsl:template>
	<xsl:template match="note" priority="1" />
</xsl:stylesheet>