<?xml version="1.0" encoding="UTF-8"?>
<!-- This stylesheet converts XMI1.2 into a visual display of the contents. Lovely and colourful. -->
<xsl:stylesheet       xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
      xmlns:UML="org.omg.xmi.namespace.UML"
      version="1.0">
	<xsl:output method="html"/>
	<xsl:template match="//XMI.header"></xsl:template>
	<xsl:template match="/">
   		<html>
   			<head>
   				<title>XMI as HTML</title>
   				<script>
   					<xsl:attribute name="type"><xsl:text>text/javascript</xsl:text></xsl:attribute>
					<xsl:text>

function hide(id) {
	document.getElementById(id).style.display = "none";
}
					</xsl:text>
				</script>	
   			</head>
   			<body>
   				<xsl:apply-templates/>
   			</body>
   		</html>
   	</xsl:template>
   	
   	<xsl:template match="//XMI.content/UML:Diagram">
   		<h1><xsl:attribute name="class">diagram</xsl:attribute><xsl:value-of select="@name"/></h1>
   		<xsl:apply-templates select="UML:GraphElement.contained/*"/>
   	</xsl:template>
   	<xsl:template match="UML:GraphElement.contained/UML:GraphNode[UML:GraphElement.semanticModel/UML:Uml1SemanticModelBridge]">
   		<div>
   			<xsl:attribute name="id"><xsl:value-of select="@xmi.id"/></xsl:attribute>
   			<xsl:attribute name="onmousedown">
   				<xsl:text>JavaScript:hide('</xsl:text>
   				<xsl:value-of select="@xmi.id"/>
   				<xsl:text>');</xsl:text>
   			</xsl:attribute>
   			<!-- location -->
   			<xsl:attribute name="style">
   				<xsl:text>position:absolute;</xsl:text>
   				<xsl:text>left:</xsl:text><xsl:value-of select="UML:GraphElement.position/XMI.field[1]"/><xsl:text>;</xsl:text>
   				<xsl:text>top:</xsl:text><xsl:value-of select="UML:GraphElement.position/XMI.field[2]"/><xsl:text>;</xsl:text>
   				<xsl:text>width:</xsl:text><xsl:value-of select="UML:GraphNode.size/XMI.field[1]"/><xsl:text>;</xsl:text>
   				<xsl:text>height:</xsl:text><xsl:value-of select="UML:GraphNode.size/XMI.field[2]"/><xsl:text>;</xsl:text>
   			</xsl:attribute>
   			<!-- content -->
   			<xsl:for-each select="UML:GraphElement.semanticModel/UML:Uml1SemanticModelBridge/UML:Uml1SemanticModelBridge.element/*">
   				<xsl:variable name="modelof"><xsl:value-of select="@xmi.idref"/></xsl:variable>
   				<xsl:for-each select="//*[@xmi.id = $modelof]">
   					<xsl:value-of select="@name"/>
   				</xsl:for-each>
   			</xsl:for-each>
   			<!-- children -->
   			<xsl:for-each select="UML:GraphElement.contained/*">
   				<xsl:apply-templates/>
   			</xsl:for-each>
   		</div>
   	</xsl:template>
   	<xsl:template match="XMI.field"/>
   	<xsl:template match="UML:Stereotype.baseClass"/>
   	<xsl:template match="UML:Model"/>
</xsl:stylesheet>