VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHtx32.OCX"
Begin VB.Form frmHypertext 
   Caption         =   "Contents"
   ClientHeight    =   3315
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   12540
   Icon            =   "frmHypertext.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3315
   ScaleWidth      =   12540
   StartUpPosition =   3  'Windows Default
   Tag             =   "frmHypertext"
   Begin VB.CommandButton cmdHypertextOK 
      Cancel          =   -1  'True
      Caption         =   "OK"
      Height          =   495
      Left            =   5400
      TabIndex        =   2
      Top             =   2760
      Width           =   1215
   End
   Begin RichTextLib.RichTextBox rtfHypertext 
      Height          =   2295
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   12495
      _ExtentX        =   22040
      _ExtentY        =   4048
      _Version        =   393217
      Enabled         =   -1  'True
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmHypertext.frx":1CF2
   End
   Begin VB.Label lblContents 
      Caption         =   "&Contents"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Tag             =   "frmHypertext.lblContents"
      Top             =   120
      Width           =   2655
   End
End
Attribute VB_Name = "frmHypertext"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

Option Explicit

Private document As CNode
Private current As CNode
Private targetLines As Dictionary 'this dictionary maps node id to line number
Private launchLines As Dictionary 'this dictionary maps line number to href
Private idLines As Dictionary ' this dictionary maps line number to node id
Private lineNumber As Long
Private startLine As Long ' the line the cursor is first placed on

Public Sub SetDiagram(newUMLDoc As CNode)
    On Error Resume Next
    Set document = newUMLDoc
End Sub

Public Sub SetCurrent(newCurrentNode As CNode)
    On Error Resume Next
    Set current = newCurrentNode
End Sub

Private Sub cmdHypertextOK_Click()
    On Error Resume Next
    Dim targetID As String
    Dim currentLineNumber As Long
    Dim i As Integer
    'switch back to main form, changing view to that of this hypertext display
    'work out the previous target line
    currentLineNumber = GetCurrentLineIndex(rtfHypertext)
    'loop back until we find something
    Debug.Print currentLineNumber
    While targetID = Empty And currentLineNumber > 0
        If idLines.Exists(currentLineNumber) Then
            targetID = idLines(currentLineNumber)
        Else
            currentLineNumber = currentLineNumber - 1
        End If
    Wend
    'if we found the target id, go there
    'Debug.Print "Target id=" & targetID & " name=" & complete(targetID).name
    If Len(targetID) > 0 Then
        Call frmMain.GoToNode(targetID)
        Call Me.Hide
    Else
        Call Me.Hide
        Call SendKeys("^{HOME}")
    End If
End Sub

Private Sub Form_Activate()
    On Error Resume Next
    Set targetLines = New Dictionary
    Set launchLines = New Dictionary
    Set idLines = New Dictionary

    'go through the document and current node to display contents
    lineNumber = -1
    rtfHypertext.Text = Trim(ParseNode(document))
    'move the cursor to the current node
    startLine = GetCharacterIndexOfLine(rtfHypertext, targetLines(currentNode.id))
    rtfHypertext.SelStart = startLine
    Call rtfHypertext.SetFocus
End Sub

Private Function ParseNode(aNode As CNode) As String
    On Error Resume Next
    Dim iterator As CNode
    Dim output As String
    Dim add As String
    Dim destination As Variant
    Dim attributeIterator As CAttribute
    
    'name
    output = output & "[" & aNode.displayName & "]" & vbNewLine
    lineNumber = lineNumber + 1
    Call targetLines.add(aNode.id, lineNumber)
    Call idLines.add(lineNumber, aNode.id)
    'parent
    If Not (aNode.parent Is Nothing) Then
        output = output & frmMain.language.GetText("Parent") & ": " & aNode.parent.name & vbNewLine
        lineNumber = lineNumber + 1
        Call launchLines.add(lineNumber, aNode.parent.id)
    End If
    'attributes
    For Each attributeIterator In aNode.attributes
        output = output & attributeIterator.description & vbNewLine
        lineNumber = lineNumber + 1
    Next attributeIterator
    'connections
    For Each destination In aNode.connections
        'see frmMain.lstConnections population in Display for how this works
         If complete(destination.target).isConnectionEnd Then
            'connected to a connectionEnd
            If complete(destination.target).parent.id = currentNode.id Then
                output = output & destination.name & vbNewLine
            Else
                'link to another node, which is a connection node: use the name of the connection node
                ' not the connectionEnd
                output = output & complete(complete(destination.target).other).name & vbNewLine
            End If
        Else
            'connected to a node
            'now, the name of the connection is the name of the connection...
            output = output & destination.name & vbNewLine
        End If
        lineNumber = lineNumber + 1
        Call launchLines.add(lineNumber, destination.target)
    Next destination
    'children
    If aNode.childNodes.Count > 0 Then
        output = output & vbNewLine & vbNewLine 'Children of " & aNode.displayName & vbNewLine
        lineNumber = lineNumber + 2
        For Each iterator In aNode.childNodes
            output = output & ParseNode(iterator)
        Next iterator
        output = output & vbNewLine ' "End of children of " & aNode.displayName & vbNewLine
        lineNumber = lineNumber + 1
    End If
    'add a newline
    output = output & vbNewLine
    lineNumber = lineNumber + 1
    ParseNode = output
End Function

Private Sub Form_Load()
    On Error Resume Next
    Me.Icon = frmMain.Icon
End Sub


Private Sub Form_Resize()
    On Error Resume Next
    If Me.Height > lblContents.Height + cmdHypertextOK.Height + 800 Then
        rtfHypertext.Height = Me.Height - lblContents.Height - cmdHypertextOK.Height - 800
        cmdHypertextOK.Top = rtfHypertext.Top + rtfHypertext.Height + 200
    End If
    If Me.Width > cmdHypertextOK.Width Then
        cmdHypertextOK.Left = (Me.Width - cmdHypertextOK.Width) / 2
        rtfHypertext.Width = Me.Width
    End If
End Sub

Private Sub rtfHypertext_KeyPress(KeyAscii As Integer)
    On Error Resume Next
    Dim line As Long
    Dim targetID As String
    
    If KeyAscii = vbKeyReturn Then
        line = GetCurrentLineIndex(rtfHypertext)
        If launchLines.Exists(line) Then
            'okay, this line corresponds to a node id
            targetID = launchLines.item(line)
            'now find the line corresponding to this id and move the cursor there
            rtfHypertext.SelStart = GetCharacterIndexOfLine(rtfHypertext, targetLines.item(targetID))
        Else
            'no internal link for this line: check to see if it is an object title
            If idLines.Exists(line) Then
                Call cmdHypertextOK_Click
            End If
        End If
    ElseIf KeyAscii = vbKeyBack Then
        'go back to first position in text field
        rtfHypertext.SelStart = startLine
    End If
End Sub
