VERSION 5.00
Begin VB.Form frmInsertNode 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Insert node"
   ClientHeight    =   1905
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4770
   Icon            =   "frmInsertNode.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1905
   ScaleWidth      =   4770
   StartUpPosition =   3  'Windows Default
   Tag             =   "frmInsertNode"
   Begin VB.CommandButton cmdInsertNodeCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3480
      TabIndex        =   5
      Tag             =   "frmInsertNode.cmdInsertNodeCancel"
      ToolTipText     =   "frmInsertNode.cmdInsertNodeCancel"
      Top             =   1440
      Width           =   1215
   End
   Begin VB.CommandButton cmdInsertNodeOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   375
      Left            =   3480
      TabIndex        =   4
      Top             =   960
      Width           =   1215
   End
   Begin VB.ListBox lstTypes 
      Height          =   255
      Left            =   1200
      TabIndex        =   3
      Top             =   600
      Width           =   3495
   End
   Begin VB.TextBox txtNodeName 
      Height          =   285
      Left            =   1200
      TabIndex        =   1
      Top             =   120
      Width           =   3495
   End
   Begin VB.Label lblNodetype 
      Caption         =   "Node &type"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Tag             =   "frmInsertNode.lblNodetype"
      Top             =   600
      Width           =   1455
   End
   Begin VB.Label lblNodename 
      Caption         =   "Node &name"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Tag             =   "frmInsertNode.lblNodename"
      Top             =   120
      Width           =   1455
   End
End
Attribute VB_Name = "frmInsertNode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

Option Explicit

Private Sub cmdInsertNodeCancel_Click()
    On Error Resume Next
    Call Me.Hide
End Sub

Private Sub cmdInsertNodeOK_Click()
    On Error Resume Next
    'add a node to the diagram
    Dim newNode As New CNode
    newNode.name = txtNodeName.Text
    newNode.nodeType = lstTypes.List(lstTypes.listIndex)
    newNode.id = GetTickCount & "-" & Date & "-" & Time
    Set newNode.parent = currentNode
    Call currentNode.AddChild(newNode)
    Call complete.add(newNode, newNode.id)
    Call diagramNodes.add(newNode, newNode.id)
    If Not frmShow.nodeTypesToShow.Exists(newNode.nodeType) Then
        'type is not down to show: is it down to hide?
        If frmShow.nodeTypesToHide.Exists(newNode.nodeType) Then
            'yep, no problem
        Else
            'nope, it just isn't in the show list. Add it.
            Call frmShow.nodeTypesToShow.add(newNode.nodeType, newNode.nodeType)
        End If
    End If
    Call Me.Hide
End Sub

Private Sub Form_Activate()
    On Error Resume Next
    cmdInsertNodeOK.Enabled = False
    lstTypes.Selected(0) = True
    txtNodeName.Text = Empty
    Call txtNodeName.SetFocus
End Sub

Private Sub Form_Load()
    On Error Resume Next
    Me.Icon = frmMain.Icon
    Call lstTypes.AddItem(frmMain.language.GetText("Select a node type..."))
    Select Case currentNode.nodeType
        Case "Model"
            Call lstTypes.AddItem("Actor")
            Call lstTypes.AddItem("Class")
            Call lstTypes.AddItem("Type")
            Call lstTypes.AddItem("Use Case")
            Call lstTypes.AddItem("Object")
            Call lstTypes.AddItem("Implementation Class")
            Call lstTypes.AddItem("Template")
            Call lstTypes.AddItem("Data Type")
            Call lstTypes.AddItem("Component")
            Call lstTypes.AddItem("Node")
            Call lstTypes.AddItem("Package")
        Case "Package"
            Call lstTypes.AddItem("Actor")
            Call lstTypes.AddItem("Class")
            Call lstTypes.AddItem("Type")
            Call lstTypes.AddItem("Use Case")
            Call lstTypes.AddItem("Object")
            Call lstTypes.AddItem("Implementation Class")
            Call lstTypes.AddItem("Template")
            Call lstTypes.AddItem("Data Type")
            Call lstTypes.AddItem("Component")
            Call lstTypes.AddItem("Node")
            Call lstTypes.AddItem("Package")
      End Select
End Sub

Private Sub lstTypes_Click()
    On Error Resume Next
    Call CheckOK
End Sub

Private Sub CheckOK()
    On Error Resume Next
    'checks if we can accept this node
    If Len(txtNodeName.Text) > 0 And Not lstTypes.Selected(0) Then
        cmdInsertNodeOK.Enabled = True
    Else
        cmdInsertNodeOK.Enabled = False
    End If
End Sub

Private Sub txtNodeName_Change()
    On Error Resume Next
    Call CheckOK
End Sub
