VERSION 5.00
Begin VB.Form frmMap 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Map of diagram"
   ClientHeight    =   1590
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   Icon            =   "frmMap.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1590
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Tag             =   "frmMap"
   Begin VB.CommandButton cmdMapOK 
      Cancel          =   -1  'True
      Caption         =   "OK"
      Height          =   495
      Left            =   1680
      TabIndex        =   2
      Top             =   960
      Width           =   1215
   End
   Begin VB.TextBox txtMap 
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   4455
   End
   Begin VB.Label lblMap 
      Caption         =   "&Map of diagram"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Tag             =   "frmMap.lblMap"
      Top             =   120
      Width           =   3855
   End
End
Attribute VB_Name = "frmMap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const MAP_SIZE As Integer = 8
Private Const HALF_MAP_SIZE As Single = MAP_SIZE / 2
Private map(0 To MAP_SIZE, 0 To MAP_SIZE) As String ' maps joystick location to ids of nodes
Private mapNames(0 To MAP_SIZE, 0 To MAP_SIZE) As String

Public Sub JoystickCallback()
    On Error Resume Next
    Dim x As Integer
    Dim y As Integer
    Dim vx As Single
    Dim vy As Single
    Static oldName As String
    
    'work out where joystick is
    x = modJoystickManager.x / COORDINATE_MAX * MAP_SIZE
    y = modJoystickManager.y / COORDINATE_MAX * MAP_SIZE
    vx = (x - HALF_MAP_SIZE) / HALF_MAP_SIZE
    vy = (y - HALF_MAP_SIZE) / HALF_MAP_SIZE
    'display name, if any
    txtMap.Text = mapNames(x, y)
    txtMap.SelStart = 0
    txtMap.SelLength = Len(txtMap.Text)
    'play sound
    If Len(txtMap.Text) > 0 Then
        If txtMap.Text <> oldName Then
            Call StopMapSound
            Call PlayMapSound(vx, vy)
            oldName = txtMap.Text
        Else
            'already playing this sound, don't do anything
        End If
    Else
        Call StopMapSound
        oldName = Empty
    End If
        
    If modJoystickManager.button = 0 Then
        'pressed trigger
        If Len(txtMap.Text) > 0 Then
            'somewhere to go
            Call Me.Hide
            Call StopMapSound
            Call frmMain.GoToNode(map(x, y))
        End If
    End If
End Sub

Public Sub GenerateMap()
    On Error Resume Next
'populate the map with the current diagram
    Dim nodeIterator As CNode
    Dim exitIterator As CExit
    Dim maxX As Long
    Dim minX As Long
    Dim maxY As Long
    Dim minY As Long
    Dim width As Long
    Dim height As Long
    Dim nodeX As Long
    Dim nodeY As Long
    Dim i As Integer
    Dim j As Integer
    Dim nodesDisplayed As Collection ' holds the nodes we'll actually put on the map
    Dim gotNode As CNode
    
    'first, clear the map
    For i = 0 To MAP_SIZE
        For j = 0 To MAP_SIZE
            map(i, j) = Empty
            mapNames(i, j) = Empty
        Next j
    Next i
    'work out what nodes to show: should be ones for the current location
    Set nodesDisplayed = New Collection
    For Each exitIterator In currentNode.exits
        If complete(exitIterator.target).isConnectionEnd Then
            Set gotNode = complete(exitIterator.target).parent
        Else
            Set gotNode = complete(exitIterator.target)
        End If
        Call nodesDisplayed.add(gotNode, gotNode.id)
    Next exitIterator
    'Assertion: nodesDisplayed contains all the nodes to put on the map
    maxX = -2000000000
    maxY = -2000000000
    minX = 2000000000
    minY = 2000000000
    'first, find size of diagram
    For Each nodeIterator In nodesDisplayed
        If nodeIterator.location.placed Then
            If nodeIterator.location.x > maxX Then maxX = nodeIterator.location.x
            If nodeIterator.location.x < minX Then minX = nodeIterator.location.x
            If nodeIterator.location.y > maxY Then maxY = nodeIterator.location.y
            If nodeIterator.location.y < minY Then minY = nodeIterator.location.y
        End If
    Next nodeIterator
    'ASSERTION: minX to maxX and minY to maxY represent the whole range of nodes
    width = maxX - minX
    If width = 0 Then
        width = 1
        maxX = maxX + 1
    End If
    height = maxY - minY
    If height = 0 Then
        height = 1
        maxY = maxY + 1
    End If
    'ASSERTION: width and height are the dimensions of the map area
    'now add nodes to the map
    For Each nodeIterator In nodesDisplayed
        If nodeIterator.location.placed Then
            nodeX = nodeIterator.location.x - minX
            nodeY = nodeIterator.location.y - minY
            nodeX = (nodeX / width) * MAP_SIZE
            nodeY = (nodeY / height) * MAP_SIZE
            map(nodeX, nodeY) = nodeIterator.id
            mapNames(nodeX, nodeY) = nodeIterator.name
            'now do the surrounding nodes : make them bigger
            For i = nodeX - 1 To nodeX + 1
                For j = nodeY - 1 To nodeY + 1
                    'test map position is valid and use it
                    If i > -1 And i < MAP_SIZE And j > -1 And j < MAP_SIZE Then
                        map(i, j) = nodeIterator.id
                        mapNames(i, j) = nodeIterator.name
                    End If
                Next j
            Next i
        End If
    Next nodeIterator
''    Dim itemp As Integer
''    Dim jtemp As Integer
''    Dim line As String
''    For itemp = 0 To MAP_SIZE
''        line = Empty
''        For jtemp = 0 To MAP_SIZE
''            If map(itemp, jtemp) = "" Then
''                line = line & "."
''            Else
''                line = line & "X"
''            End If
''        Next jtemp
''        Debug.Print line
''    Next itemp
End Sub

Private Sub cmdMapOK_Click()
    On Error Resume Next
    Call StopMapSound
    Call Me.Hide
End Sub

Private Sub Form_Load()
    On Error Resume Next
    Me.Icon = frmMain.Icon
End Sub

