Attribute VB_Name = "modAPIFunctions"
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

Option Explicit

Private Const MAX_LINE_LENGTH As Long = 200

Public Sub Scroll(ByRef editControl As Control, lines As Long)
'scrolls the editControl textbox by lines lines
' editControl - the current control
' lines - the number of lines to scroll

    On Error Resume Next

    Call SendMessageW(editControl.hWnd, EM_LINESCROLL, 0, lines)
End Sub

Public Sub ScrollToCursor(ByRef editControl As Control)
'scrolls the editControl textbox to where the cursor is now
' editControl - the current control
    On Error Resume Next
    Call SendMessageW(editControl.hWnd, EM_SCROLLCARET, 0, 0)
End Sub

Public Function GetCurrentLine(ByRef editControl As Control) As String
'returns the text on the current line from the current control
'   editControl - the current control
'   charPos - the position of the cursor in the control

    On Error Resume Next

    Dim gotLine As String ' the line we get back
    Dim lineNumber As Long ' the line number of the current line
    'get the line number: arguments of -1 mean "line with caret", 0 is not used
    lineNumber = SendMessage(editControl.hWnd, EM_LINEFROMCHAR, -1, 0)
    'now get this line and return it
    gotLine = Space(MAX_LINE_LENGTH)
    'first two words have to be a Long, size of String
    gotLine = Chr$(MAX_LINE_LENGTH Mod 256) + Chr$(MAX_LINE_LENGTH / 256) & gotLine
    Call SendMessage(editControl.hWnd, EM_GETLINE, lineNumber, ByVal gotLine)
    GetCurrentLine = gotLine
End Function

Public Function GetCurrentLineIndex(ByRef editControl As Control) As Long
'returns the number of the current line indicated by the cursor
    'get the line number: arguments of -1 mean "line with caret", 0 is not used

    On Error Resume Next

    GetCurrentLineIndex = SendMessage(editControl.hWnd, EM_LINEFROMCHAR, -1, 0)
End Function

Public Function GetNumberedLine(ByRef editControl As Control, lineNumber As Long) As String
'returns the numbered line

    On Error Resume Next

    Dim gotLine As String ' the line we get back
    'now get this line and return it
    gotLine = Space(MAX_LINE_LENGTH)
    'first two words have to be a Long, size of String
    gotLine = Chr$(MAX_LINE_LENGTH Mod 256) + Chr$(MAX_LINE_LENGTH / 256) & gotLine
    Call SendMessage(editControl.hWnd, EM_GETLINE, lineNumber, ByVal gotLine)
    GetNumberedLine = gotLine
End Function

Public Function GetNumberOfLines(ByRef editControl) As Long
'returns the number of lines in the control

    On Error Resume Next

    GetNumberOfLines = SendMessage(editControl.hWnd, EM_GETLINECOUNT, 0, 0)
End Function



Public Function GetCharacterIndexOfLine(ByRef editControl, lineNumber As Long) As Long
'returns the number of characters in the control up to the numbered line

    On Error Resume Next

    GetCharacterIndexOfLine = SendMessage(editControl.hWnd, EM_LINEINDEX, lineNumber, 0)
End Function
