Attribute VB_Name = "modGeometryUtilities"
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

Option Explicit

'A bunch of utility functions

Public Const PI As Double = 3.142

Public Function CalculateAngleBetween(x As Integer, y As Integer, a As Integer, b As Integer) As Integer
    On Error Resume Next
'return the number of degrees from x,y to a,b
    Dim xd As Double
    Dim yd As Double
    Dim ad As Double
    Dim bd As Double
    Dim result As Double
    On Error GoTo errorHandler:
    'shift everything so its positive
    If x < 0 Then
        a = a - x
        x = 0
    End If
    If a < 0 Then
        x = x - a
        a = 0
    End If
    If y < 0 Then
        b = b - y
        y = 0
    End If
    If b < 0 Then
        y = y - b
        b = 0
    End If
    If x = a And y = b Then
        'trying to calculate angle from a point to itself: not valid
        result = -1
    Else
        xd = CDbl(x)
        yd = CDbl(y)
        ad = CDbl(a)
        bd = CDbl(b)
        If a > x Then
            'from is west of to
            result = Atn((b - y) / (a - x)) * 180# / PI + 90#
        ElseIf a < x Then
            'from is east of to
            result = Atn((b - y) / (a - x)) * 180# / PI + 270#
        Else
            'a = x
            If b > y Then
                result = 180#
            Else
                result = 0#
            End If
        End If
    End If
    CalculateAngleBetween = CInt(result)
    Exit Function
errorHandler:
    CalculateAngleBetween = -1
    Exit Function
End Function
