Attribute VB_Name = "modSequenceDiagramFunctions"
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

Option Explicit

Public Sub AddMessagesToSequenceDiagram(diagramNode As CNode)
'takes a CNode and goes through each of the objects in the diagram creating
'connections between the object and its messages
    On Error Resume Next
    Dim nodeIterator As CNode
    Dim allIterator As CNode
    Dim myName As String
    Dim newConnection As CConnection
   
    For Each nodeIterator In diagramNode.childNodes
        'got a sequence diagram node
        myName = nodeIterator.name
        For Each allIterator In diagramNodes
            If myName = allIterator.messageNodeName Then
                Set newConnection = New CConnection
                newConnection.id = nodeIterator.id & "-" & GetTickCount & "-" & Rnd
                newConnection.target = allIterator.id
                newConnection.connectionType = allIterator.nodeType
                Call nodeIterator.AddConnection(newConnection)
            End If
        Next allIterator
        'now sort into time order
        Call SortChildrenByTime(nodeIterator)
    Next nodeIterator
End Sub

Private Sub SortChildrenByTime(aNode As CNode)
'sorts the child nodes of aNode into time order
    On Error GoTo stopSorting:
    Dim swap As Boolean
    Dim i As Integer
    Dim swapNode As CNode
    
    swap = True
    While swap
        swap = False
        For i = 1 To aNode.childNodes.Count - 1
            If aNode.childNodes.item(i).nodeTime > aNode.childNodes.item(i + 1).nodeTime Then
                Set swapNode = aNode.childNodes.item(i)
                Call aNode.childNodes.Remove(i)
                Call aNode.childNodes.add(swapNode, swapNode.id, , i)
                swap = True
            End If
        Next i
    Wend
    Exit Sub
stopSorting:
    Exit Sub
End Sub
