Attribute VB_Name = "modSound"
'Accessible UML

'LICENCE
'This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'"Accessible UML" is copyright 2001-2004 Paul Blenkhorn and Gareth Evans, at UMIST,
'and is released by them under the GNU Public Licence Version 3. A copy is available
'at http://www.gnu.org/licenses/gpl.txt
'The code was written by Alasdair King.

Option Explicit

Private Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long
Private Const SND_ASYNC = &H1         '  play asynchronously

Public Sub PlayErrorSound()
    On Error Resume Next
    If frmMain.mnuOptionsSounds.Checked Then
        Call PlaySound(App.path & "\sounds\error.wav", 0, SND_ASYNC)
    End If
End Sub

Public Sub PlayTurnSound()
    On Error Resume Next
    If frmMain.mnuOptionsSounds.Checked Then
        Call PlaySound(App.path & "\sounds\turn.wav", 0, SND_ASYNC)
    End If
End Sub

Public Sub PlaySoundFile(path As String)
    On Error Resume Next
    'works out what type of file is indicated by path, wav or midi, and
    'calls the appropriate function to play it. Finds wav files by
    'preference to midi files
    Dim fso As New FileSystemObject
    If fso.FileExists(path & ".wav") Then
        'found a matching wav file
        path = path & ".wav"
        'can use simple DLL call
        Call PlaySound(path, 0, SND_ASYNC)
    ElseIf fso.FileExists(path & ".mid") Then
        'found a matching midi file
        path = path & ".mid"
        'need to use DirectSound
        Call modSpatialSound.PlayMidi(path, 0)
    Else
        'no match - do nothing
    End If
End Sub
